#!/bin/sh
#
# Startup script for odtransform.
#
# Usage: odtransform <Main-options>.
#
#
if test "$JAVA_HOME" = ""
then
  JAVA_CMD=java
else
  JAVA_CMD=$JAVA_HOME/bin/java
fi

# This code is copied from maven's mvn startup script.
if [ -z "$ODTRANSFORM_HOME" ] ; then
  ## resolve links - $0 may be a link to odtransform's home
  PRG="$0"

  # need this for relative symlinks
  while [ -h "$PRG" ] ; do
    ls=`ls -ld "$PRG"`
    link=`expr "$ls" : '.*-> \(.*\)$'`
    if expr "$link" : '/.*' > /dev/null; then
      PRG="$link"
    else
      PRG="`dirname "$PRG"`/$link"
    fi
  done

  saveddir=`pwd`

  ODTRANSFORM_HOME=`dirname "$PRG"`/..

  # make it fully qualified
  ODTRANSFORM_HOME=`cd "$ODTRANSFORM_HOME" && pwd`

  cd "$saveddir"
fi

LOG4JPROPS=$ODTRANSFORM_HOME/conf/log4j.properties

DEBUG=0

while test $# -ge 1
do
    case "$1" in
    --debug)         LOG4JPROPS=$ODTRANSFORM_HOME/conf/log4j_debug.properties
        shift 1
        ;;
    --debug-startup) DEBUG=1
        shift 1
        ;;    
    --quiet)         LOG4JPROPS=$ODTRANSFORM_HOME/conf/log4j_quiet.properties
        shift 1
        ;;
    --verbose)       LOG4JPROPS=$ODTRANSFORM_HOME/conf/log4j_verbose.properties
        shift 1
        ;;
    * )
        break
        ;;
    esac
done

for jar in $ODTRANSFORM_HOME/lib/*.jar
do
   CLASSPATH="${CLASSPATH:+${CLASSPATH}:}$jar"
done

if test $DEBUG -ne 0
then
    echo '*****************************************************'
    echo $JAVA_CMD -Dlog4j.configuration=file:$LOG4JPROPS -cp $CLASSPATH org.clazzes.odtransform.OdtTransform $*
    echo '*****************************************************'
fi

$JAVA_CMD -Dlog4j.configuration=file:$LOG4JPROPS -cp $CLASSPATH org.clazzes.odtransform.OdtTransform $*
